function getRandomColor(%dR, %dG, %dB)
{
	%red = getRandom() / %dR;
	%grn = getRandom() / %dG;
	%blu = getRandom() / %dB;
	%color = %red SPC %grn SPC %blu SPC "1";
	return %color;
}

function Player::Zombify(%obj)
{
	if(!isObject(%obj))
	{
		return;
	}
	%obj.isZombie = true;
	%obj.playThread(0, armReadyBoth);
	%data = %obj.getDatablock();
	%skincolor = %data.color;
	if(isObject(%client = %obj.getControllingClient()))
	{
		%obj.setShapeNameColor("0.15 0.3 0.3");
		%headcolor = %client.headcolor;
		%obj.setNodeColor("headskin", %skincolor);
		if(%client.rhandColor $= %headcolor)
		{
			%obj.setNodeColor("Rhand", %skincolor);
		}
		if(%client.lhandColor $= %headcolor)
		{
			%obj.setNodeColor("Lhand", %skincolor);
		}
		if(%client.rarmColor $= %headcolor)
		{
			%obj.setNodeColor($Rarm[%client.rarm], %skincolor);
		}
		if(%client.larmColor $= %headcolor)
		{
			%obj.setNodeColor($Larm[%client.larm], %skincolor);
		}
		if(%client.chestColor $= %headcolor)
		{
			%obj.setNodeColor($chest[%client.chest], %skincolor);
		}
		if(%client.rlegColor $= %headcolor)
		{
			%obj.setNodeColor("Rshoe", %skincolor);
		}
		if(%client.llegColor $= %headcolor)
		{
			%obj.setNodeColor("Lshoe", %skincolor);
		}
		if(%client.hipColor $= %headcolor)
		{
			%obj.setNodeColor("pants", %skincolor);
		}
	}
	else
	{
		%obj.hideNode("ALL");
		%obj.unhideNode("headskin");
		%obj.setNodeColor("headskin", %skincolor);
		%color = getRandomColor(2, 2, 2);
		switch(getRandom() > 0.5)
		{
			case true: %node = "chest";
			default: %node = "femchest";
		}
		%obj.unhideNode(%node);
		%obj.setNodeColor(%node, %color);
		switch(getRandom() > 0.5)
		{
			case true: %node = "arm";
			default: %node = "armSlim";
		}
		%obj.unhideNode("L" @ %node);
		%obj.unhideNode("R" @ %node);
		switch(getRandom(1, 3))
		{
			case 1:
				%obj.setNodeColor("L" @ %node, %color);
				%obj.setNodeColor("R" @ %node, %color);
			case 2:
				%obj.setNodeColor("L" @ %node, %skincolor);
				%obj.setNodeColor("R" @ %node, %color);
			case 3:
				%obj.setNodeColor("L" @ %node, %color);
				%obj.setNodeColor("R" @ %node, %skincolor);
			default:
				%obj.setNodeColor("L" @ %node, %skincolor);
				%obj.setNodeColor("R" @ %node, %skincolor);
		}
		if(getRandom(1, 7) == 7)
		{
			%obj.unhideNode(%node = "skirtHip");
			%obj.unhideNode(%lf = "skirtTrimLeft");
			%obj.unhideNode(%rf = "skirtTrimRight");
			%obj.setNodeColor(%node, getRandomColor(2, 2, 2));
			%obj.setNodeColor(%lf, getRandomColor(3, 3, 3));
			%obj.setNodeColor(%rf, getRandomColor(2, 2, 2));
		}
		else
		{
			%obj.unhideNode(%node = "pants");
			%obj.unhideNode(%lf = "Lshoe");
			%obj.unhideNode(%rf = "Rshoe");
			%obj.setNodeColor(%node, getRandomColor(2, 3, 4));
			%shoecolor = getRandomColor(2, 3, 4);
			switch(getRandom(1, 3))
			{
				case 1:
					%obj.setNodeColor(%lf, %shoecolor);
					%obj.setNodeColor(%rf, %shoecolor);
				case 2:
					%obj.setNodeColor(%lf, %skincolor);
					%obj.setNodeColor(%rf, %shoecolor);
				case 3:
					%obj.setNodeColor(%lf, %shoecolor);
					%obj.setNodeColor(%rf, %skincolor);
				default:
					%obj.setNodeColor(%lf, %skincolor);
					%obj.setNodeColor(%rf, %skincolor);
			}
		}
		%obj.unhideNode(%lf = "lhand");
		%obj.unhideNode(%rf= "rhand");
		%obj.setNodeColor(%lf, %skincolor);
		%obj.setNodeColor(%rf, %skincolor);
		switch(%n = getRandom(0, 7))
		{
			case 1: %hat = "helmet";
			case 2: %hat = "pointyHelmet";
			case 3: %hat = "flareHelmet";
			case 4: %hat = "scoutHat";
			case 5: %hat = "bicorn";
			case 6: %hat = "copHat";
			case 7: %hat = "knitHat";
		}
		if(%n >= 1 && strLen(%hat) > 0)
		{
			%obj.unhideNode(%hat);
			%obj.setNodeColor(%hat, getRandomColor(2, 2, 2));
		}
		if(%n > 3 && strLen(%hat) > 0)
		{
			switch(getRandom(1, 4))
			{
				case 1: %node = "plume";
				case 2: %node = "triPlume";
				case 3: %node = "septPlume";
			}
			if(strLen(%node) > 0)
			{
				%obj.unhideNode(%node);
				%obj.setNodeColor(%node, getRandomColor(1.5, 1.5, 1.5));
			}
		}
		switch(getRandom() > 0.5)
		{
			case true: %obj.setFaceName("AsciiTerror");
			default: %obj.setFaceName("Orc");
		}
		switch(getRandom(1, 7))
		{
			case 1: %obj.setDecalName("HCZombie");
			case 2: %obj.setDecalName("Hoodie");
			case 3: %obj.setDecalName("Meme-Mongler");
			case 4: %obj.setDecalName("Chef");
			case 5: %obj.setDecalName("worm-sweater");
			case 6: %obj.setDecalName("worm_engineer");
		}
	}
}