package CraftsmenZombies
{
	function player::unmountImage(%obj, %slot)
	{
		if(%obj.getMountedImage(%slot) == BlankImage.getID())
		{
			return;
		}
		parent::unmountImage(%obj, %slot);
	}
	function armor::onNewDatablock(%this, %obj)
	{
		parent::onNewDatablock(%this, %obj);
		if(%this.isZombie)
		{
			%obj.schedule(0, zombify);
			%obj.schedule(0, clearTools);
			%scale = %this.size;
			if(%scale !$= "1 1 1" && getWordCount(%scale) == 3)
			{
				%obj.setScale(%scale);
			}
			if(!isObject(%obj.client))
			{
				%obj.schedule(250, initZombieSearchLoop);
			}
		}
	}
	function armor::onTrigger(%this, %obj, %slot, %val)
	{
		parent::onTrigger(%this, %obj, %slot, %val);
		if(%this.isZombie && %slot == 0 && %val)
		{
			%obj.breakBricks();
		}
	}
	function armor::onMount(%this, %obj, %vehicle, %seat)
	{
		parent::onMount(%this, %obj, %vehicle, %seat);
		if(%this.isZombie && !%vehicle.isZombie)
		{
			%obj.schedule(10, dismount);
		}
	}
	function player::setDatablock(%obj, %newData)
	{
		parent::setDatablock(%obj, %newData);
		if(%newData.isZombie)
		{
			if(isobject(%obj.client.minigame))
			{
				%obj.client.infected = true;
			}
		}
	}
	function armor::onCollision(%this, %obj, %col, %vec, %speed)
	{
		parent::onCollision(%this, %obj, %col, %vec, %speed);
		if(%this.isZombie && %obj.getState() !$= "Dead")
		{
			if(%col.getType() & $Typemasks::PlayerObjectType)
			{
				if(%col.getState() $= "Dead")
				{
					return;
				}
			}
			%omini = isObject(%oc = %obj.client) ? %oc.minigame : %obj.brickGroup.client.minigame;
			%cmini = isObject(%cc = %col.client) ? %cc.minigame : %col.brickGroup.client.minigame;
			if(!isObject(%omini) || !isObject(%cmini) || %omini != %cmini || !%omini.ZombiesEnabled)
			{
				return;
			}
			if(%obj.getDatablock().normalAttack)
			{
				ZombieCollision(%obj, %col, %speed);
			}
			else
			{
				%obj.getDatablock().ZombieCollision(%obj, %col, %speed);//Custom damage function for special datablocks
			}
		}
	}
	function player::playPain(%obj)
	{
		if(%obj.isZombie)
		{
			serverPlay3D(%obj.getPosition(), ZombiePainSound);
		}
		else
		{
			parent::playPain(%obj);
		}
	}
	function player::playDeathCry(%obj)
	{
		if(%obj.isZombie)
		{
			serverPlay3D(%obj.getPosition(), ZombiePainSound);
		}
		else
		{
			parent::playDeathCry(%obj);
		}
	}
	function ShapeBaseImageData::onFire(%this, %obj, %slot)
	{
		parent::onFire(%this, %obj, %slot);
		%om = isObject(%obj.client) ? %obj.client.minigame : %obj.brickGroup.client.minigame;
		if(%this.className $= "WeaponImage" && %om.ZombiesEnabled)
		{
			InitContainerRadiusSearch(%opos = %obj.getPosition(), %om.Zombies_SightRadius, $Typemasks::PlayerObjectType);
			while(%hit = ContainerSearchNext())
			{
				%hm = isObject(%hit.client) ? %hit.client.minigame : %hit.brickGroup.client.minigame;
				if(%hm == %om && %hit.getDatablock().isZombie && %hit.getDatablock().normalSearch)
				{
					if(!isObject(%hit.target))
					{
						%chase = true;
					}
					else
					{
						%hpos = %hit.getPosition();
						%tpos = %hit.target.getPosition();
						if(vectorDist(%hpos, %tpos) > vectorDist(%hpos, %opos))
						{
							%chase = true;
						}
					}
					if(%chase)
					{
						%hit.target = %obj;
						%hit.setMoveObject(%obj);
					}
				}
			}
		}
		%end = vectorAdd(%opos, vectorScale(%obj.getEyeVector(), %om.Zombies_SightRadius));
		%ray = containerRaycast(%opos, %end, $Typemasks::PlayerObjectType);
		if(isObject(%hit = firstWord(%ray)))
		{
			%hm = isObject(%hit.client) ? %hit.client.minigame : %hit.brickGroup.client.minigame;
			if(%hm == %om && %hm.ZombiesEnabled)
			{
				%hit.setMoveX(getRandom(-1, 1));
				%hit.schedule(500, setMoveX, 0);
			}
		}
	}
	function minigameCanDamage(%a, %b)
	{
		%parent = parent::minigameCanDamage(%a, %b);
		if(%parent == 0 || !isObject(%a) || !isObject(%b))
		{
			return %parent;
		}
		%ac = %a.getClassName() $= "GameConnection" ? %a : %a.client;
		%bc = %b.getClassName() $= "GameConnection" ? %b : %b.client;
		if(!isObject(%ac) || !isObject(%bc))
		{
			return %parent;
		}
		%am = %ac.minigame;
		%bm = %bc.minigame;
		if(!isObject(%am) || !isObject(%bm) || %am != %bm || !%am.zombiesEnabled || %am.enablePvP || %ac.infected == %bc.infected == 0)
		{
			return %parent;
		}
		return false;
	}
	function player::damage(%obj, %sourceObject, %pos, %amt, %type)
	{
		if(isObject(%sourceObject))
		{
			switch$(%sourceObject.getClassName())
			{
				case "Player": %client = %sourceObject.client;
				case "AIPlayer": %client = %sourceObject.client;
				case "Projectile": %client = %sourceObject.client;
				case "WheeledVehicle": %client = %sourceObject.getMountedObject(0).client;
			}
			if(%obj.isZombie && isObject(%client.player) && %obj.brickGroup.client.minigame == %client.minigame && %client.minigame.zombiesEnabled)
			{
				%obj.setMoveObject(%client.player);
				%obj.target = %client.player;
			}
		}
		parent::damage(%obj, %sourceObject, %pos, %amt, %type);
		if(isObject(%obj) && %obj.getState() $= "Dead" && isObject(%sourceObject))
		{
			if(isObject(%mini = %client.minigame))
			{
				%omini = isObject(%obj.client) ? %obj.client.minigame : %obj.brickGroup.client.minigame;
				if(%omini == %mini && %mini.zombiesEnabled)
				{
					%points = %mini.points_PlayerKillZombie;
					if(isObject(%obj.getControllingClient()))
					{
						%points-= %mini.points_KillPlayer;
					}
					%client.incScore(%points);
				}
			}
		}
	}
	function gameConnection::onDeath(%this, %sourceObj, %sourceClient, %damageType, %damageLocation)
	{
		if(!isObject(%this.minigame) && (%this.isOut || %this.infected))
		{
			%this.infected = false;
			%this.isOut = false;
		}
		parent::onDeath(%this, %sourceObj, %sourceClient, %damageType, %damageLocation);
		if(!%this.minigame.Zombies_PlayersRespawn && isObject(%this.minigame))
		{
			%this.isOut = true;
			messageClient(%this, 'MsgYourSpawn');
			%this.setControlObject(%this.camera);
			%this.camera.setFlyMode();
			%this.minigame.checkForEnd(2);
			return;
		}
		%mini = %this.minigame;
		if(%sourceObj.isZombie && %mini.InfectionEnabled && !%this.infected)
		{
			%this.infected = true;
			if(isObject(%sourceClient))
			{
				%sourceClient.incScore(%mini.Points_ZombieKillPlayer);
			}
			%mini.bottomPrintAll("\c3" @ %this.name @ "\c0 became a Zombie.", 5);
			%mini.checkForEnd(1);
		}
	}
	function gameConnection::spawnPlayer(%this)
	{
		if(%this.isOut && isObject(%this.minigame))
		{
			%this.setControlObject(%this.camera);
			%this.camera.setFlyMode();
			return;
		}
		if(!isObject(%this.minigame) && (%this.isOut || %this.infected))
		{
			%this.infected = false;
			%this.isOut = false;
		}
		parent::spawnPlayer(%this);
		if(%this.infected && isObject(%this.minigame))
		{
			if(%data = %this.zombieDatablock)
			{
				%this.player.setDatablock(%data);
				if(%this.zombieDatablock.normalZombify)
				{
					%scale = %this.zombieDatablock.size;
					if(%scale !$= "1 1 1" && getWordCount(%scale) == 3)
					{
						%this.player.setScale(%scale);
					}
				}
			}
			else
			{
				%this.player.setDatablock(ZombieStandardArmor);
			}
			%this.bottomPrint("\c2Now playing as a \c3" @ %this.player.getDatablock().name @ "\c2.", 5);
			%this.player.spawnBrick = %this.spawnBrick;
			%this.player.clearTools();
		}
	}
	function MinigameSO::pickSpawnPoint(%this, %client)
	{
		if(!%client.infected)
		{
			return parent::pickSpawnPoint(%this, %client);
		}
		%spawnList = "";
		if(%this.useAllPlayersBricks)
		{
			for(%i = 0; %i < %this.numMembers; %i++)
			{
				%currGroup = %this.member[%i].brickGroup;
				for(%ii = 0; %ii < %currGroup.getCount(); %ii++)
				{
					%brick = %currGroup.getObject(%ii);
					if(%brick.vehicleDatablock.isZombie && %brick.vehicleDatablock.playable)
					{
						%spawnList = %spawnList SPC %brick;
					}
				}
			}
		}
		else
		{
			for(%i = 0; %i < %this.owner.brickGroup.getCount(); %i++)
			{
				%brick = %this.owner.brickGroup.getObject(%i);
				if(%brick.vehicleDatablock.isZombie && %brick.vehicleDatablock.playable)
				{
					%spawnList = %spawnList SPC %brick;
				}
			}
		}
		if(getWordCount(%spawnList) > 0)
		{
			%ran = -1;
			while(!isObject(%brick = getWord(%spawnList, %ran)))
			{
				%ran = getRandom(0, getWordCount(%spawnList) - 1);
			}
			%client.zombieDatablock = %brick.vehicleDatablock;
			%client.spawnBrick = %brick;
			return %brick.vehicleSpawnMarker.getTransform();
		}
		else return parent::pickSpawnPoint(%this, %client);
	}
	function serverCmdCreateMinigame(%client, %miniName)
	{
		parent::serverCmdCreateMinigame(%client, %miniName);
		commandToClient(%client, 'sendZMGprefs');
		%client.resetVehicles();
		%client.minigame.scheduleGameEnd();
	}
	function serverCmdEndMinigame(%client)
	{
		%mini = %client.minigame;
		for(%i = 0; %i < %mini.numMembers; %i++)
		{
			%mini.member[%i].isOut = false;
			%mini.member[%i].infected = false;
		}
		parent::serverCmdEndMinigame(%client);
		%client.resetVehicles();
	}
	function serverCmdResetMinigame(%client)
	{
		%mini = %client.minigame;
		for(%i = 0; %i < %mini.numMembers; %i++)
		{
			%mini.member[%i].isOut = false;
			%mini.member[%i].infected = false;
		}
		parent::serverCmdResetMinigame(%client);
		cancel(%mini.gameEndSched);
		%mini.scheduleGameEnd();
	}
	function serverCmdLeaveMinigame(%client)
	{
		%client.infected = false;
		%client.isOut = false;
		parent::serverCmdLeaveMinigame(%client);
	}
	function gameConnection::applyBodyColors(%this)
	{
		parent::applyBodyColors(%this);
		if(%this.player.isZombie)
		{
			%this.player.zombify();
		}
	}
	function fxDTSbrick::setRecolorVehicle(%this, %bool)
	{
		if(%this.vehicle.isZombie)
		{
			return;
		}
		parent::setRecolorVehicle(%this, %bool);
	}
};
activatePackage(CraftsmenZombies);